#include <bits/stdc++.h>
using namespace std;


template<class T, class Comp>
struct SegmentTree {
    T inf;
    int sz;
    Comp comp;
    vector<T> t;

    template<class It>
    SegmentTree(It from, It to, T inf) 
        : inf(inf) {
        int n = distance(from, to);
        sz = 1;
        while (sz < n) sz *= 2;
        t.assign(sz * 2, inf);
        copy(from, to, t.begin() + sz);
        for (int i = sz - 1; i; --i) {
            t[i] = min(t[i * 2], t[i * 2 + 1], comp);
        }
    }

    T get(int from, int to) {
        T res = inf;
        for (int x = from + sz, y = to + sz; x < y; x /= 2, y /= 2) {
            if (x & 1) res = min(res, t[x++], comp);
            if (y & 1) res = min(res, t[--y], comp);
        }
        return res;
    }
};


void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> a(m);
    for (int &x : a) {
        cin >> x;
    }
    vector<int> b(m);
    for (int &x : b) {
        cin >> x;
    }

    SegmentTree<int, greater<int>> as(a.begin(), a.end(), -(int)2e9);
    SegmentTree<int, greater<int>> bs(b.begin(), b.end(), -(int)2e9);

    long long answer = 0;
    for (int width = 1; width <= m; ++width) {
        int window = min(m, width + 1);
        int height = n;
        for (int i = 0; i + window <= m; ++i) {
            int cura = as.get(i, i + window);
            int curb = bs.get(i, i + window);
            height = min(height, n - cura - curb);
        }
        answer = max(answer, (long long) height * width);
    }

    cout << answer << '\n';
}


int main() {
    ios::sync_with_stdio(false);
    int tests = 1;
    // cin >> tests;
    for (int i = 0; i < tests; ++i) {
        solve();
    }
}
