#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>

using namespace std;

#define TASK ""
typedef long long ll;
const int INF = (int)1e9 + 23;
const ll LINF = (ll)1e18 + 23;
const int dd = (int)1e4 + 3;

int solve();

int main() {
	ios_base::sync_with_stdio(0);
#ifdef home
	freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#else 
	cin.tie(0);
	cout.tie(0);
	if (TASK != "") freopen(TASK".in", "r", stdin), freopen(TASK".out", "w", stdout);
#endif
	solve();
	return 0;
}

template <class T> 
struct queueMax {
	vector<pair<T, T>> vb, ve;

	void push(T x) {
		int maxE = x;
		if (!ve.empty()) maxE = max(maxE, ve.back().second);
		ve.push_back({x, maxE});	
	}

	void pop() {
		if (vb.empty()) {
			while (!ve.empty()) {
				int maxE = ve.back().first;
				if (!vb.empty()) maxE = max(maxE, vb.back().second);
				vb.push_back({ve.back().first, maxE});
				ve.pop_back();
			}
		}
		vb.pop_back();
	}

	int getMax() {
		int maxE = -((1ll << 31) - 1);
		if (!vb.empty()) maxE = max(maxE, vb.back().second);
		if (!ve.empty()) maxE = max(maxE, ve.back().second);
		return maxE;
	}

	void clear() {
		vb.clear(); ve.clear();
	}

	int size() {
		return vb.size() + ve.size();
	}
};

void print(queueMax<int> &q) {
	for (auto x: q.vb) cout << x.first << ' ';
	cout << endl;
	for (auto x: q.ve) cout << x.first << ' ';
	cout << endl;
} 
int up[dd], down[dd];

int solve() {
	int n, m;
	cin >> n >> m;

	for (int i = 1; i <= m; i++) cin >> up[i];
	for (int i = 1; i <= m; i++) cin >> down[i];

	ll ans = 0;
	queueMax<int> qUp, qDown;
	for (int w = 1; w <= m; w++) {
		int h = n;
		qUp.clear(), qDown.clear();
		for (int i = 1; i <= m; i++) {
			qUp.push(up[i]);
			qDown.push(down[i]);
			
			h = min(h, n - qUp.getMax() - qDown.getMax());
			if (i > w)  {qUp.pop(); qDown.pop();}
		}
		
		if (h *1ll * w > ans) {
			ans = h *1ll* w;
		}
	}

	cout << ans;
	return 0;
}