import collections
import sys


Gnome = collections.namedtuple('Gnome', ['height', 'floor'])


def solve(gnomes, minfloor):
    x = max(min(g.floor, g.height - minfloor + 1) for g in gnomes)
    x = max(x, 1)
    return sum(max(0, g.floor - x) for g in gnomes)


def main(infile, outfile):
    cnt, minfloor = map(int, input().split())
    gnomes = []
    for i in range(cnt):
        h, f = map(int, input().split())
        gnomes.append(Gnome(h, f))
    answer = solve(gnomes, minfloor)
    print(answer)


if __name__ == '__main__':
    main(sys.stdin, sys.stdout)
