#include <bits/stdc++.h>
using namespace std;

struct Gnome {
    int h, f, i;
};

bool operator<(Gnome const &a, Gnome const &b) {
    if (a.h != b.h) return a.h < b.h;
    if (a.f != b.f) return a.f < b.f;
    if (a.i != b.i) return a.i < b.i;
    return false;
}

bool operator==(Gnome const &a, Gnome const &b) {
    return a.h == b.h && a.f == b.f && a.i == b.i;
}


long long solve(vector<Gnome> gnomes, int minfloor) {
    for (auto &g : gnomes) {
        g.h -= minfloor - 1;
    }

    map<int, vector<Gnome>> f2g;
    for (auto g : gnomes) {
        f2g[g.f].push_back(g);
    }
    
    set<Gnome> have(gnomes.begin(), gnomes.end());

    vector<int> floors;
    floors.push_back(1);
    for (auto g : gnomes) {
        floors.push_back(g.f);
        if (g.h > 0) {
            floors.push_back(g.h);
        }
    }
    sort(floors.begin(), floors.end());
    floors.erase(unique(floors.begin(), floors.end()), floors.end());
    
    int last = 0;
    for (int f : floors) {
        if (f > 1 && have.rbegin()->h < f) break;
        last = f;
        for (auto g : f2g[f]) {
            have.erase(g);
        }
        if (have.empty()) break;
    }
    
    long long answer = 0;
    for (auto g : have) {
        answer += g.f - last;
    }
    return answer;
}


int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int cnt, minfloor;
    cin >> cnt >> minfloor;
    vector<Gnome> gnomes;
    for (int i = 0; i < cnt; ++i) {
        int h, f;
        cin >> h >> f;
        gnomes.push_back({h, f, i});
    }
    auto answer = solve(gnomes, minfloor);
    cout << answer << '\n';
}
