import collections
import sys


Gnome = collections.namedtuple('Gnome', ['height', 'floor'])


def solve(gnomes, minfloor):
    maxh = max(g.height for g in gnomes)
    answer = 0
    for gnome in gnomes:
        answer += max(0, gnome.floor + minfloor - maxh)
    return answer


def main(infile, outfile):
    cnt, minfloor = map(int, input().split())
    gnomes = []
    for i in range(cnt):
        h, f = map(int, input().split())
        gnomes.append(Gnome(h, f))
    answer = solve(gnomes, minfloor)
    print(answer)


if __name__ == '__main__':
    main(sys.stdin, sys.stdout)
