#include <bits/stdc++.h>

const int maxn = 1e5 + 10;

int mem[maxn][2];

int dfs(const std::vector<std::vector<int>> &graph,
        int p, int v, bool flag) {
    if (mem[v][flag] != -1) {
        return mem[v][flag];
    }
    int s = 0;
    std::vector<int> children(graph[v].size());
    for (int i = 0; i < (int)graph[v].size(); i++) {
        int u = graph[v][i];
        if (u == p) {
            continue;
        }
        int value = dfs(graph, v, u, true);
        children[i] = value;
        s += value;
    }
    if (!flag) {
        return mem[v][flag] = s;
    } else {
        int t = INT_MAX;
        for (int i = 0; i < (int)graph[v].size(); i++) {
            int u = graph[v][i];
            if (u == p) {
                continue;
            }
            t = std::min(t, dfs(graph, v, u, false) + 1 + s - children[i]);
        }
        return mem[v][flag] = std::min(s + 1, t);
    }
}

int main() {
    int n;
    scanf("%d", &n);
    std::vector<std::vector<int>> gr(n);
    for (int i = 0; i < n - 3; i++) {
        int a, b;
        scanf("%d%d", &a, &b);
        a--, b--;
        gr[a].push_back(b);
        gr[b].push_back(a);
    }
    for (int i = 0; i < n; i++) {
        int to = (i + 1) % n;
        gr[i].push_back(to);
        gr[to].push_back(i);
    }
    for (int i = 0; i < n; i++) {
        std::sort(gr[i].begin(), gr[i].end(), [&](int x, int y) {
            return (x - i + n) % n < (y - i + n) % n;
        });
    }
    std::map<std::vector<int>, int> triangleToVertex;
    std::set<std::pair<int, int>> edges;
    std::vector<std::vector<int>> graph(n - 2);
    int cnt = 0;
    for (int i = 0; i < n; i++) {
        int previous = -1;
        for (int j = 0; j + 1 < (int)gr[i].size(); j++) {
            std::vector<int> triangle = {i, gr[i][j], gr[i][j + 1]};
            std::sort(triangle.begin(), triangle.end());
            if (triangleToVertex.find(triangle) == triangleToVertex.end()) {
                triangleToVertex[triangle] = cnt++;
            }
            int num = triangleToVertex[triangle];
            if (previous != -1 && edges.count({previous, num}) == 0) {
                graph[num].push_back(previous);
                graph[previous].push_back(num);
                edges.insert({previous, num});
                edges.insert({num, previous});
            }
            previous = num;
        }
    }

    for (int i = 0; i < maxn; i++) {
        for (int j = 0; j < 2; j++) {
            mem[i][j] = -1;
        }
    }

    printf("%d\n", dfs(graph, -1, 0, true));
    return 0;
}
