#include "testlib.h"
#include <cmath>
#include <algorithm>

using namespace std;

const long long LIM = 1000000000000000000;
const long double EPS = 1e-3;

bool is_prime(int x) {
    for (int i = 2; i * i <= x; i++) {
        if (x % i == 0) {
            return false;
        }
    }
    return true;
}

int next_prime(int x) {
    while (!is_prime(x)) {
        x++;
    }
    return x;
}

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);
    int MAXN = atoi(argv[1]);
    int MAXX = atoi(argv[2]);
    int P = atoi(argv[3]);
    while (!is_prime(MAXX)) {
        MAXX--;
    }

    vector<int> a, b;
    long double lg = 0;
    for (int i = 0; i < MAXN; i++) {
        int val = rnd.next(1, MAXX);
        if (rnd.next(1, 100) <= P) {
            val = next_prime(val);
        }
        a.push_back(val);
        lg += logl((long double) a.back());
    }
    for (int i = 0; i < MAXN; i++) {
        int val = rnd.next(1, MAXX);
        if (rnd.next(1, 100) <= P) {
            val = next_prime(val);
        }
        b.push_back(val);
        lg -= logl((long double) b.back());
    }
    if (lg < 0) {
        a.swap(b);
        lg = -lg;
    }
    while (lg + EPS >= logl(LIM)) {
        lg -= logl(a.back());
        a.pop_back();
    }

    cout << a.size() << " " << b.size() << endl;
    for (size_t i = 0; i < a.size(); i++) {
        if (i != 0) {
            cout << " ";
        }
        cout << a[i];
    }
    cout << endl;
    for (size_t i = 0; i < b.size(); i++) {
        if (i != 0) {
            cout << " ";
        }
        cout << b[i];
    }
    cout << endl;
}