#include "testlib.h"
#include <cmath>
#include <algorithm>

using namespace std;

const long long LIM = 1000000000000000000;
const long double EPS = 1e-3;

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);
    int MAXN = atoi(argv[1]);
    int MAXX = atoi(argv[2]);
    vector<int> a, b;
    long double lg = 0;
    for (int i = 0; i < MAXN; i++) {
        a.push_back(rnd.next(1, MAXX));
        lg += logl((long double) a.back());
    }
    for (int i = 0; i < MAXN; i++) {
        b.push_back(rnd.next(1, MAXX));
        lg -= logl((long double) b.back());
    }
    if (lg < 0) {
        a.swap(b);
        lg = -lg;
    }
    while (lg + EPS >= logl(LIM)) {
        lg -= logl(a.back());
        a.pop_back();
    }
    
    cout << a.size() << " " << b.size() << endl;
    for (size_t i = 0; i < a.size(); i++) {
        if (i != 0) {
            cout << " ";
        }
        cout << a[i];
    }
    cout << endl;
    for (size_t i = 0; i < b.size(); i++) {
        if (i != 0) {
            cout << " ";
        }
        cout << b[i];
    }
    cout << endl;
}
