#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
#include <bitset>
#include <string>
#include <unordered_map>

using namespace std;

#define TASK ""
typedef long long ll;
typedef unsigned long long ull;
const int INF = (int)1e9 + 23;
const ll LINF = (ll)1e18 + 23;

int solve();

int main() {
	ios_base::sync_with_stdio(0);
#ifdef home
	freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#else 
	cin.tie(0);
	cout.tie(0);
	if (TASK != "") freopen(TASK".in", "r", stdin), freopen(TASK".out", "w", stdout);
#endif
	solve();
	return 0;
}

vector<ull> P;
 
ull gcd(ull a, ull b) {
    while (b)
        a %= b, swap(a, b);
    return a;
}
 
ull get(ull n) {
    for (ull i : P) {
        if (i * i > n)
            return 1;
        if (n % i == 0)
            return i;
    }
 
    ull c1 = (ull)pow(n, 1.0 / 3) + 6;
 
    for (ull k = 1; k <= c1; k++) {
        ull c2 = (ull)(pow(n, 1.0 / 6) / (4 * sqrt(k))) + 6;
        for (ull d = 0; d <= c2; d++) {
            ull A = (ull)(2 * sqrt(k) * sqrt(n)) + d;
 
            for (int i = 0; i < 2; i++, A++) {
                ull t = A * A - 4 * k * n;
           
                if (t < 0)
                    continue;
                ull B = (ull)(sqrt(t));
                if (B * B == t) {
                    ull dd = gcd(A - B, n);
                    if (1 < dd && dd < n && n % dd == 0)
                        return dd;
                }
                B++;
                if (B * B == t) {
                    ull dd = gcd(A - B, n);
                    if (1 < dd && dd < n && n % dd == 0)
                        return dd;
                }
            }
        }
    }
    return 1;
}
 
bitset<1234> F;

vector<ull> ans;
 
void fact(ull n) {
    if (n == 1)
        return;
    ull div = get(n);
    if (div == 1)
        ans.push_back(n);
    else {
        fact(n / div);
        fact(div);
    }
}
 
int solve() {
    for (int i = 2; i <= 1000; i++) F[i] = 1;

    for (ull i = 2; i * i <= 1000; i++)
        if (F[i]) {
            for (ull j = i * i; j <= 1000; j += i)
                F[j] = 0;
        }
    for (ull i = 2; i <= 1000; i++)
        if (F[i])
            P.push_back(i);
 
 	int n, m; cin >> n >> m;
   	unordered_map<int, int> powers;

 	for (int i = 0; i < n; i++) {
 		int x; cin >> x;
 		ans.clear();
 		fact(x);
 		for (auto p : ans) {
 			powers[p]++;
 		}
 	}

 	for (int i = 0; i < m; i++) {
 		int x; cin >> x;
 		ans.clear();
 		fact(x);
 		for (auto p : ans) {
 			powers[p]--;
 		}
 	}

 	long double f = 1;
 	for (auto p : powers) {
 		long double cur = 1;
 		for (int i = 0; i < abs(p.second); i++) cur *= p.first;
 		if (p.second > 0) f *= cur;
 		else f /= cur;
	} 		

	cout << (long long) round((double)f);
    return 0;
}