#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int MOD = 998244353;

int sign(int x) {
    if (x > 0) return 1;
    if (x < 0) return -1;
    return 0;
}

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    size_t n;
    cin >> n;
    vector<int> x(n), y(n);
    for (auto& i : x) {
        cin >> i;
    }
    for (auto& i : y) {
        cin >> i;
    }

    vector<size_t> p(n);
    for (size_t i = 0; i < n; i++) {
        p[i] = i;
    }
    long long ans = 0;
    do {
        bool ok = true;
        for (size_t i = 0; i < n; i++) {
            for (size_t j = i + 1; j < n; j++) {
                if (sign(x[i]) != sign(x[j])) {
                    continue;
                }
                if (sign(y[p[i]]) != sign(y[p[j]])) {
                    continue;
                }
                if ((x[i] < x[j]) != (y[p[i]] < y[p[j]])) {
                    ok = false;
                    break;
                }
            }
            if (!ok) {
                break;
            }
        }

        if (ok) {
            ans++;
        }
    } while (next_permutation(p.begin(), p.end()));

    cout << ans % MOD << endl;

    return 0;
}
