#include <cstdio>
#include <iostream>
#include <cassert>
#include <vector>
#include <map>
#include <string>
#include <algorithm>
#include <sstream>
#include "testlib.h"

using namespace std;

string itoa(int x) 
{
    stringstream ss;
    string s;
    ss << x;
    ss >> s;
    return s;
}

int atoi(string s) 
{
    stringstream ss;
    int x;
    ss << s;
    ss >> x;
    return x;
}

void write_test(vector<pair<int, int>> test) 
{
    cout << test.size() + 1 << endl;
    for (int i = 0; i < (int)test.size(); i++)
        cout << test[i].first << ' ' << test[i].second << endl;
}

vector<pair<int, int>> getEdges(vector<int>& p)
{
    int n = p.size();
    vector<int> a(n);
    iota(a.begin(), a.end(), 1);
    shuffle(a.begin(), a.end());
    vector<pair<int, int>> e;
    for (int i = 1; i < n; i++)
    {   
        if (rnd.next(2))
            e.push_back({a[p[i]], a[i]});
        else 
            e.push_back({a[i], a[p[i]]});
    }
    shuffle(e.begin(), e.end());
    return e;
}

void gen_ans(int n, int x)
{
    vector<int> p(n, -1);
    int k = n / x;
    assert(n % x != 0);
    int root = 0;
    
    vector<int> last(k);
    for (int j = 0; j < k; j++)
    {
        p[j * x + 1] = root;
        for (int i = 1; i < x; i++)
            p[j * x + i + 1] = j * x + i;
        last[j] = (j + 1) * x;
    }    
    for (int i = k * x + 1; i < n; i++)
    {
        int q = rnd.next(k);
        p[i] = last[q];
        last[q] = i;
    }
    write_test(getEdges(p));
}


int main(int argc, char * argv[]) 
{
    registerGen(argc, argv, 1);
    int n = atoi(argv[1]);
    int x = atoi(argv[2]);
    if (argc > 3 && atoi(argv[3]) == 1)
        n = rnd.next(n / 2, n);
    if (x == -1)
        x = rnd.next(2, n / 2);
    if (n % x == 0)
        n--;
    gen_ans(n, x);
    return 0;
}