#include <bits/stdc++.h>

void dfs(const std::vector<std::vector<int>> &graph,
         std::vector<int> &minDepth,
         std::vector<int> &answer,
         int v, int p, int depth) {
    std::vector<int> children;
    for (int u : graph[v]) {
        if (u == p) continue;
        dfs(graph, minDepth, answer, u, v, depth + 1);
        minDepth[v] = std::min(minDepth[v], minDepth[u] + 1);
        answer[v] = std::min(answer[v], answer[u]);
        children.push_back(minDepth[u]);
    }
    if (children.size() > 1) {
        std::sort(children.begin(), children.end());
        answer[v] = std::min(answer[v], children[0] + children[1] + 2);
    }
}

int main() {
    int n;
    std::cin >> n;
    if (n == 2) {
        std::cout << 1 << '\n';
        return 0;    
    }
    
    std::vector<std::vector<int>> graph(n);
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        std::cin >> a >> b;
        a--;
        b--;
        graph[a].push_back(b);
        graph[b].push_back(a);
    }
    std::vector<int> minDepth(n, INT_MAX);
    std::vector<int> answer(n, INT_MAX);

    int root = -1;
    for (int i = 0; i < n; i++) {
        if (graph[i].size() != 1) {
            root = i;
        } else {
            minDepth[i] = 0;
        }
    }
    dfs(graph, minDepth, answer, root, -1, 0);
    printf("%d\n", answer[root]);
    return 0;
}
